#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n, nulta, prva, druga, zajedno;
    string grupe;
    int koliko;

        cin >> n;
    int  A[n][4];
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < 4; ++j) A[i][j] = 0;

    int k=n;
    // prva = a, druga = b, zajedno = ab
    cin >> nulta >> prva >> druga >> zajedno;

    int rez = 0;

    for(int i = 0; i < k; i++)
    {
        cin >> grupe;
        cin >> koliko;
        if(grupe == "O"){
            nulta = nulta - koliko;
            if(nulta < 0){
                cout << "nemoguce";
                return 0;}}
        if(grupe == "A"){
            if((nulta+prva)<koliko){
                cout << "nemoguce";
                return 0;}}
        if(grupe == "B"){
            if((nulta+druga)<koliko){
                cout << "nemoguce";
                return 0;}}
        if(grupe == "AB"){
            if((nulta+prva+druga+zajedno) < koliko){
                cout << "nemoguce";
                return 0;}}
        if(grupe == "O")
        {
            nulta = nulta - koliko;
            A[i][0] = koliko;
            A[i][1] = 0;
            A[i][2] = 0;
            A[i][3] = 0;
            continue;
        }

        if(grupe == "A")
        {
            if(prva >= koliko){
                prva = prva - koliko;
               // cout << "0 " << koliko << " 0 0" << endl;
               A[i][0] = 0;
               A[i][1] = koliko;
               A[i][2] = 0;
               A[i][3] = 0;}
            else{
                nulta = nulta + prva - koliko;

                //cout << koliko - prva << " " << prva << " 0 0" << endl;
                A[i][0] = koliko-prva;
                A[i][1] = prva;
                A[i][2] = 0;
                A[i][3] = 0;}continue;
        }
        if(grupe == "B")
        {
            if(druga >= koliko){
                druga = druga - koliko;
                // cout << "0 0 " << koliko << " 0" << endl;
                A[i][0] = 0;
                A[i][1] = 0;
                A[i][2] = koliko;
                A[i][3] = 0;}
            else{
                nulta = nulta + druga - koliko;

                //cout << "0 " << koliko - druga << " " << druga << " 0" << endl;
                A[i][0] = 0;
                A[i][1] = koliko - druga;
                A[i][2] = druga;
                A[i][3] = 0;}continue;
        }
        if(grupe == "AB")
        {
            if(zajedno >= koliko){
               // cout << "0 0 0 " << koliko;

               A[i][0] = 0;
               A[i][1] = 0;
               A[i][2] = 0;
               A[i][3] = koliko;}
            else{
                rez = nulta + prva + druga + zajedno - koliko;
                if(nulta + zajedno >= koliko){
                   // cout << koliko - zajedno << " 0 0 " << zajedno;
                   A[i][0] = koliko - zajedno;
                   A[i][1] = 0;
                   A[i][2] = 0;
                   A[i][3] = zajedno;}
                else if(nulta + prva + zajedno >= koliko){
                    //cout << nulta << " " << koliko - zajedno - nulta << " 0 " << zajedno;
                    A[i][0] = nulta;
                    A[i][1] = koliko - zajedno - nulta;
                    A[i][2] = 0;
                    A[i][3] = zajedno;}
                else{
                    //cout << nulta << " " << prva << " " << koliko - zajedno - nulta - prva << " " << zajedno;
                    A[i][0] = nulta;
                    A[i][1] = prva;
                    A[i][2] = koliko - zajedno - nulta - prva;
                    A[i][3] = zajedno;}}

        }
    }

    cout << "moguce" << endl;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < 4; j++)
        {
            cout << A[i][j]<< " ";
        }
        cout << endl;
    }
    return 0;
}